#include "sdlayer.h"

static unsigned int sdlappicon_pixels[] = {
	0xfffcfffe, 0xfffcfffe, 0xfffcfffe, 0xfffcfffe, 0xfffcfffe, 0xfffcfffe,
	0xfffcfffe, 0xfffcfffe, 0xfffcfffe, 0xfffcfffe, 0xfffff2e6, 0xffffd2a3,
	0xffffb66e, 0xfffeaf5c, 0xfffeaf5c, 0xffffb15f, 0xfffeaf5c, 0xffffaa5a,
	0xffffab5b, 0xfffdb879, 0xffffd2a3, 0xfffff1e4, 0xfffcfffe, 0xfffcfffe,
	0xfffcfffe, 0xfffcfffe, 0xfffcfffe, 0xfffcfffe, 0xfffcfffe, 0xfffcfffe,
	0xfffcfffe, 0xfffcfffe, 0xfffcfffe, 0xfffcfffe, 0xfffcfffe, 0xfffcfffe,
	0xfffcfffe, 0xfffcfffe, 0xfffcfffe, 0xfffcfffe, 0xffffe8cc, 0xffffb66e,
	0xffffab5b, 0xfffdce9f, 0xfffde5c9, 0xfffff1e4, 0xfffefbf6, 0xfffff7ee,
	0xfffff2e6, 0xffffddb8, 0xfffecfa1, 0xffffc78c, 0xffffb66e, 0xffffa546,
	0xfffeb36b, 0xffffe8cc, 0xfffcfffe, 0xfffcfffe, 0xfffcfffe, 0xfffcfffe,
	0xfffcfffe, 0xfffcfffe, 0xfffcfffe, 0xfffcfffe, 0xfffcfffe, 0xfffcfffe,
	0xfffcfffe, 0xfffcfffe, 0xfffcfffe, 0xfffcfffe, 0xfffefbf6, 0xffffbb7b,
	0xfffda241, 0xffffd7ad, 0xfffff7ee, 0xfffffcfe, 0xfffffcfe, 0xfffffcfe,
	0xfffcfffe, 0xfffffcfe, 0xfffcfffe, 0xfffcf4eb, 0xffffe7d3, 0xfffcdebe,
	0xfffbd1b0, 0xffffd8ae, 0xfffcc69b, 0xffffa546, 0xffffbb7b, 0xfffefbf6,
	0xfffcfffe, 0xfffcfffe, 0xfffcfffe, 0xfffcfffe, 0xfffcfffe, 0xfffcfffe,
	0xfffcfffe, 0xfffcfffe, 0xfffcfffe, 0xfffcfffe, 0xfffcfffe, 0xffffe8cc,
	0xffff9e3e, 0xfffdb879, 0xffffe1c9, 0xffffecdd, 0xfffffdf7, 0xfffcfffe,
	0xfffff7ee, 0xffffe2c2, 0xffffd2a3, 0xfffec58a, 0xffffc07e, 0xffffc78c,
	0xffffd8ae, 0xffffe7d3, 0xffffe9cd, 0xffffeed6, 0xffffeed6, 0xfffff2e6,
	0xfffdce9f, 0xffff9e3e, 0xffffe8cc, 0xfffcfffe, 0xfffcfffe, 0xfffcfffe,
	0xfffcfffe, 0xfffcfffe, 0xfffcfffe, 0xfffcfffe, 0xfffcfffe, 0xfffcfffe,
	0xffffe7d3, 0xffff9835, 0xffffbd73, 0xffffcc98, 0xfffddab5, 0xfffff8f7,
	0xfffce4c8, 0xffffc07e, 0xffffa556, 0xffff9835, 0xfffe9631, 0xffff8b1d,
	0xffff8500, 0xffff8400, 0xffff8500, 0xffff912b, 0xffffb66e, 0xffffe1c1,
	0xfffff7ee, 0xfffff7ee, 0xfffcfffe, 0xffffe0c8, 0xffff9d3c, 0xffffe8cc,
	0xfffcfffe, 0xfffcfffe, 0xfffcfffe, 0xfffcfffe, 0xfffcfffe, 0xfffcfffe,
	0xfffcfffe, 0xfffeeada, 0xffff912b, 0xfffdb879, 0xffffbb7b, 0xfffddfbf,
	0xffffe7d3, 0xfffeaf5c, 0xffff8500, 0xffff870e, 0xfffe9631, 0xffff9d3c,
	0xffff9835, 0xffff9835, 0xffff912b, 0xffff870e, 0xffff8400, 0xffff8400,
	0xffff7f00, 0xffff870e, 0xffffb66e, 0xfffff7ee, 0xfffcfffe, 0xfffffdf7,
	0xfffdebd3, 0xffff9835, 0xfffce8d8, 0xfffcfffe, 0xfffcfffe, 0xfffcfffe,
	0xfffcfffe, 0xfffcfffe, 0xfffefbf6, 0xffff9d3c, 0xfffdb26a, 0xffffbb7b,
	0xfffdd5ab, 0xffffe0c8, 0xffff9d3c, 0xffff912b, 0xffff8400, 0xffff8b1d,
	0xffff9b21, 0xffff9e3e, 0xffff9e3e, 0xffff9b21, 0xffff8b1d, 0xffff8800,
	0xffff8500, 0xffff8400, 0xffff870e, 0xfffe8125, 0xffff8400, 0xfffea857,
	0xfffff1e4, 0xfffffbfd, 0xfffdeee2, 0xffffd2a3, 0xffff9d3c, 0xfffffdf7,
	0xfffcfffe, 0xfffcfffe, 0xfffcfffe, 0xfffcfffe, 0xffffbb7b, 0xffffb66e,
	0xfffeca96, 0xffffddb8, 0xffffdabe, 0xfffb870b, 0xffeb8500, 0xfffb870b,
	0xffffaa5a, 0xffffaa5a, 0xffff912b, 0xffff9835, 0xffff9d3c, 0xffff9835,
	0xffff912b, 0xffff870e, 0xffff7d1a, 0xffff8400, 0xffff9835, 0xfffeaf5c,
	0xffff912b, 0xffff8a19, 0xffff9406, 0xffffe2c2, 0xfffff1e4, 0xfffce4c8,
	0xffffc07e, 0xffffbb7b, 0xfffcfffe, 0xfffcfffe, 0xfffcfffe, 0xffffe9cd,
	0xffff9d3c, 0xffffd8ae, 0xfffdd5ab, 0xfffeeada, 0xffeb8500, 0xffeb8500,
	0xffeb7f00, 0xfffdb26a, 0xfffdfaf5, 0xfffee4d0, 0xfff28500, 0xffde7110,
	0xffce6715, 0xffb25903, 0xffb35a07, 0xffc66000, 0xffd86b00, 0xfff17c13,
	0xffffcb97, 0xfffffdf7, 0xffffc07e, 0xffff8a19, 0xffff7f00, 0xffff9b21,
	0xfffeeeea, 0xffffddb8, 0xfffdd5ab, 0xffff9d3c, 0xfffeeada, 0xfffcfffe,
	0xfffcfffe, 0xffffb66e, 0xfffdc995, 0xfffce4c8, 0xfffff2e6, 0xffffab5b,
	0xfffc8e23, 0xfffb870b, 0xfff9af67, 0xfffff2e6, 0xffffc594, 0xfffcc69b,
	0xffe9994f, 0xff8f5800, 0xff994e00, 0xff974a16, 0xff9d4c00, 0xff994e00,
	0xff8c4800, 0xffcb6a1c, 0xfffbd1b0, 0xfffff7ee, 0xfffcfffe, 0xffffbb7b,
	0xffff7f00, 0xffff8800, 0xffffab5b, 0xffffe7d3, 0xfffdcda7, 0xffffbd73,
	0xffffb15f, 0xfffcfffe, 0xfffff2e6, 0xfffea343, 0xfffee4d0, 0xfffff2e6,
	0xffffe1c1, 0xffff7f00, 0xffff8a19, 0xfffda241, 0xfffff2e6, 0xffffc280,
	0xffff9835, 0xffffe0c8, 0xfffce8d8, 0xffb66a12, 0xff944f00, 0xffa24f07,
	0xffa24f07, 0xff9d4c00, 0xff975e05, 0xffe8b993, 0xffffe7d3, 0xffffaa5a,
	0xffffe7d3, 0xfffffdf7, 0xffff9e3e, 0xffff8f00, 0xfffe8300, 0xffffd8ae,
	0xffffdabe, 0xffffcc98, 0xffff9d3c, 0xfffcf4eb, 0xffffd2a3, 0xffffbb7b,
	0xffffe8cc, 0xfffff2e6, 0xfffdb879, 0xffff7f00, 0xffff8800, 0xfffcdcc5,
	0xfffdeee2, 0xffffa556, 0xffffdabe, 0xfffcfffe, 0xfffffcfe, 0xffebb180,
	0xff9b5c03, 0xff924d00, 0xff944f00, 0xff8e4f00, 0xffcc7311, 0xfffffcfe,
	0xfffffcfe, 0xfffee2b9, 0xffffaa5a, 0xffffebdb, 0xffffd8ae, 0xfffe8300,
	0xffff9406, 0xffffb15f, 0xffffe8cc, 0xffffd2a3, 0xffffb66e, 0xffffd2a3,
	0xffffb66e, 0xffffc594, 0xfffee4d0, 0xffffe8cc, 0xffff9835, 0xfffe8300,
	0xffffab5b, 0xfffffef9, 0xfffecfa1, 0xffffbd73, 0xfffffcfe, 0xfffcfffe,
	0xfffcfffe, 0xfffcf9f4, 0xffd06b00, 0xffb26000, 0xffbf6000, 0xffae6f17,
	0xfffcbe7c, 0xfffcfffe, 0xfffffcfe, 0xfffffef9, 0xffffb66e, 0xffffc07e,
	0xfffff2e6, 0xffff9d3c, 0xfffc8e23, 0xffff8b1d, 0xffffe7d3, 0xffffd8ae,
	0xffffc07e, 0xffffb66e, 0xffffaa5a, 0xffffd2a3, 0xfffdebd3, 0xfffbd1b0,
	0xffff8400, 0xffff7f00, 0xfffdc995, 0xfffff7ee, 0xfffdac66, 0xfffdf0dc,
	0xfffcfffe, 0xfffcfffe, 0xfffffcfe, 0xfffffcfe, 0xfffdf0dc, 0xfffff1e4,
	0xfffffdf7, 0xfffce4c8, 0xfffcfffe, 0xfffffcfe, 0xfffcfffe, 0xfffcfffe,
	0xfffdf0dc, 0xffffa556, 0xfffeeada, 0xffffc78c, 0xffff8a19, 0xfffe8125,
	0xffffd2a3, 0xfffce4c8, 0xfffdcda7, 0xfffdac66, 0xffffaa5a, 0xffffd8ae,
	0xffffefd7, 0xffffc78c, 0xffff7f00, 0xffff8800, 0xffffddb8, 0xffffe2c2,
	0xffff9e3e, 0xfffcfffe, 0xfffcfffe, 0xfffcfffe, 0xfffcfffe, 0xfffcfffe,
	0xfffcfffe, 0xfffeeeea, 0xfff1e7ca, 0xfffcfffe, 0xfffcfffe, 0xfffcfffe,
	0xfffcfffe, 0xfffcfffe, 0xfffffdf7, 0xffff9e3e, 0xffffddb8, 0xffffd8ae,
	0xffff8400, 0xffff8400, 0xffffc594, 0xffffe9cd, 0xffffd7ad, 0xffffaa5a,
	0xfffdae5b, 0xffffe7d3, 0xfffff7ee, 0xffffc280, 0xffff7f00, 0xffff8e00,
	0xfffdeee2, 0xffffe9cd, 0xfffeca96, 0xfffcfffe, 0xfffcfffe, 0xfffcfffe,
	0xfffcfffe, 0xfffcfffe, 0xfff6dec2, 0xffad6806, 0xff926700, 0xffe98300,
	0xfffffbfd, 0xfffcfffe, 0xfffcfffe, 0xfffcfffe, 0xfffcfffe, 0xffffc594,
	0xfffee4d0, 0xffffeed6, 0xffff8e00, 0xffff8500, 0xffffbd73, 0xffffecdd,
	0xffffddb8, 0xffffab5b, 0xffffab5b, 0xffffecdd, 0xfffdf9fb, 0xffffc07e,
	0xffff8400, 0xffff9406, 0xffffc594, 0xfffdce9f, 0xffe7ba8b, 0xffdfb78e,
	0xffdfb283, 0xffddb081, 0xffefbb8f, 0xfffcfffe, 0xffe0b88f, 0xff8c6000,
	0xff8d4d17, 0xffb86700, 0xfffdfaf5, 0xffffebdb, 0xffe4b787, 0xffddb081,
	0xffe2bb91, 0xffe6b98a, 0xfffeca96, 0xffffbb7b, 0xffff8500, 0xfffe8125,
	0xffffc280, 0xffffecdd, 0xfffedbb6, 0xffffaa5a, 0xffffb15f, 0xffffecdd,
	0xfffffdf7, 0xfffdcda7, 0xffff8b1d, 0xffff8e00, 0xffff8800, 0xffff8500,
	0xffc0670d, 0xff8a5203, 0xff935500, 0xff845200, 0xffb26d16, 0xfffeeeea,
	0xfffdf9fb, 0xffc27611, 0xffa0671c, 0xffeeaf76, 0xfffcfffe, 0xffe9994f,
	0xff926700, 0xff905104, 0xff8a5203, 0xffb26000, 0xffff8400, 0xffff7f00,
	0xfffe8125, 0xffff7f00, 0xffffc594, 0xffffeed6, 0xffffd7ad, 0xfffdae5b,
	0xfffdac66, 0xffffe1c9, 0xfffffef9, 0xffffddb8, 0xffff912b, 0xffff912b,
	0xffff9406, 0xffff8a19, 0xffde7110, 0xff974a16, 0xffa24f07, 0xff9d4c00,
	0xff9a5b00, 0xffe1a369, 0xfffcfffe, 0xfffdfaf5, 0xfffcf4eb, 0xfffcfffe,
	0xfffeeada, 0xffb66a12, 0xff965106, 0xffa24f07, 0xff974a16, 0xffd86b00,
	0xffff7f00, 0xffff8800, 0xffff8400, 0xffff8500, 0xffffd2a3, 0xfffeeada,
	0xfffdcda7, 0xffffaa5a, 0xffffb66e, 0xfffedbb6, 0xfffdfaf5, 0xfffeefe3,
	0xffff9d3c, 0xffff8a19, 0xffff8d23, 0xffff870e, 0xfffa8000, 0xffb25903,
	0xff964b00, 0xff9d4c00, 0xff9d4c00, 0xffad6806, 0xfffbd1b0, 0xfffcfffe,
	0xfffcfffe, 0xfffcfffe, 0xffdc831c, 0xff8c5914, 0xffa24f07, 0xff994e00,
	0xffa24f07, 0xfff77b10, 0xffff7d1a, 0xffff8500, 0xffff7f00, 0xffff9406,
	0xfffeeada, 0xffffe2c2, 0xffffc78c, 0xfffdb879, 0xffffd2a3, 0xffffc280,
	0xfffdf0dc, 0xfffff7ee, 0xffffb66e, 0xffff7f00, 0xffff870e, 0xfffe8125,
	0xffff7d00, 0xffd46800, 0xff9d4c00, 0xff9d4c00, 0xff935500, 0xffcf7c24,
	0xfffdf9fb, 0xfffcfffe, 0xfffcfffe, 0xfffcfffe, 0xfff0cbaf, 0xff9f5a00,
	0xff994e00, 0xff9d4c00, 0xffd56900, 0xffff7d1a, 0xfffe8125, 0xfffe8125,
	0xfffe8125, 0xffffb15f, 0xffffecdd, 0xfffddfbf, 0xffffbd73, 0xffffd2a3,
	0xfffff2e6, 0xffffa556, 0xfffde5c9, 0xffffecdd, 0xffffddb8, 0xffff7f00,
	0xfffe8125, 0xffff7f00, 0xffff7f00, 0xffff7a00, 0xffd06b00, 0xff8e4f00,
	0xffaf5e00, 0xfffdf9fb, 0xfffffef9, 0xfffcfffe, 0xfffcfffe, 0xfffcfffe,
	0xfffffef9, 0xffe6a261, 0xff975e05, 0xffbf6000, 0xffff7f00, 0xffff7f00,
	0xffff7f00, 0xffff8400, 0xffff8400, 0xffffddb8, 0xfffce4c8, 0xfffdd5ab,
	0xffff9d3c, 0xfffcf4eb, 0xfffffcfe, 0xfffdac66, 0xffffc280, 0xffffddb8,
	0xffffecdd, 0xffffab5b, 0xfffb8d1f, 0xffff7f00, 0xfff77b10, 0xffff7f00,
	0xffff7f00, 0xffcc7311, 0xffe6a261, 0xfffff2e6, 0xfffcfffe, 0xfffcfffe,
	0xfffcfffe, 0xfffcfffe, 0xffffeed6, 0xffffe2c2, 0xffdc831c, 0xffff8400,
	0xffff7a00, 0xffff7f00, 0xffff7f00, 0xffff8f00, 0xffffa546, 0xfffeeada,
	0xffffd2a3, 0xfffdc489, 0xffffb15f, 0xfffcfffe, 0xfffcfffe, 0xffffeed6,
	0xffff9835, 0xfffdcda7, 0xfffdd5ab, 0xfffdebd3, 0xffff9406, 0xfffb870b,
	0xffff7f00, 0xffff7f00, 0xffff7f00, 0xffffa556, 0xffffecdd, 0xfffeaf5c,
	0xffffaa5a, 0xfffeb36b, 0xfffeb36b, 0xffffb15f, 0xffffa041, 0xffffdabe,
	0xffffe1c9, 0xffff8400, 0xffff7f00, 0xffff7f00, 0xffff8a19, 0xffff9406,
	0xffffebdb, 0xffffcc98, 0xfffdcda7, 0xffff9d3c, 0xffffebdb, 0xfffcfffe,
	0xfffffcfe, 0xfffcfffe, 0xffffbd73, 0xffffb15f, 0xfffbd1b0, 0xffffe1c9,
	0xffffe2c2, 0xffff8c00, 0xfffb870b, 0xffff7f00, 0xfffa8000, 0xffffc594,
	0xfffffcfe, 0xfffcf4eb, 0xfffcead2, 0xffffe8cc, 0xfffee4d0, 0xffffe7d3,
	0xfffdfaf5, 0xfffffcfe, 0xfffedbb6, 0xffff8a19, 0xffff8400, 0xffff8c00,
	0xffff8a19, 0xffffe2c2, 0xfffee4d0, 0xffffcc98, 0xffffb66e, 0xffffbd73,
	0xfffcfffe, 0xfffcfffe, 0xfffcfffe, 0xfffcfffe, 0xfffdf9fb, 0xffff9d3c,
	0xffffbd73, 0xfffdce9f, 0xffffe2c2, 0xfff9dfcc, 0xffff9d3c, 0xffff8c00,
	0xfffe8125, 0xffff8e00, 0xffffaa5a, 0xffffc78c, 0xffffd8ae, 0xffffe7d3,
	0xfffeeada, 0xffffddb8, 0xffffc78c, 0xffffa546, 0xffff8400, 0xffff8400,
	0xffff8a19, 0xffffa12b, 0xfffde5c9, 0xffffe1c9, 0xffffcc98, 0xffffc280,
	0xffff9e3e, 0xfffffcfe, 0xfffcfffe, 0xfffcfffe, 0xfffcfffe, 0xfffffef9,
	0xfffcfffe, 0xfffeeada, 0xffff9406, 0xffffc594, 0xffffd2a3, 0xffffe8cc,
	0xfffeeada, 0xffffb15f, 0xfffe8125, 0xffff7f00, 0xffff8400, 0xffff7d1a,
	0xffff8a19, 0xffff9406, 0xffff912b, 0xffff8a19, 0xffff7f00, 0xffff8800,
	0xffff8400, 0xffff7f00, 0xfffdac66, 0xffffecdd, 0xfffdebd3, 0xffffd2a3,
	0xfffdcda7, 0xffff9835, 0xffffe9cd, 0xfffcfffe, 0xfffcfffe, 0xfffcfffe,
	0xfffcfffe, 0xfffcfffe, 0xfffcfffe, 0xfffffef9, 0xffffe7d3, 0xffff9b21,
	0xffffc280, 0xfffddab5, 0xfffddfbf, 0xfffff2e6, 0xffffe2c2, 0xffffb66e,
	0xffff9835, 0xffff8a19, 0xffff8500, 0xffff7f00, 0xffff8400, 0xffff8400,
	0xffff870e, 0xffff9835, 0xffffb76f, 0xffffddb8, 0xffffecdd, 0xffffdabe,
	0xffffdabe, 0xffffc594, 0xffff9b21, 0xfffdebd3, 0xfffcfffe, 0xfffcfffe,
	0xfffcfffe, 0xfffcfffe, 0xfffcfffe, 0xfffcfffe, 0xfffcfffe, 0xfffcfffe,
	0xfffffcfe, 0xfffee4d0, 0xffff9e3e, 0xffffbb7b, 0xffffe2c2, 0xffffe2c2,
	0xfffff3e7, 0xfffff3e7, 0xffffebdb, 0xffffd8ae, 0xfffecfa1, 0xffffc280,
	0xffffc78c, 0xffffd2a3, 0xffffd8ae, 0xfffdebd3, 0xfffdf0dc, 0xfffdebd3,
	0xffffddb8, 0xffffddb8, 0xffffc280, 0xffffa041, 0xffffe7d3, 0xfffffef9,
	0xfffcfffe, 0xfffcfffe, 0xfffcfffe, 0xfffcfffe, 0xfffcfffe, 0xfffcfffe,
	0xfffcfffe, 0xfffcfffe, 0xfffcfffe, 0xfffcfffe, 0xfffffdf7, 0xffffbd73,
	0xffff9e3e, 0xffffcc98, 0xffffe2c2, 0xffffe9cd, 0xffffe8cc, 0xfffff1e4,
	0xfffff2e6, 0xfffdf9fb, 0xfffffdf7, 0xfffff2e6, 0xffffecdd, 0xfffee4d0,
	0xffffe7d3, 0xffffdabe, 0xfffeca96, 0xffff9e3e, 0xffffbb7b, 0xfffffcfe,
	0xfffffef9, 0xfffcfffe, 0xfffcfffe, 0xfffcfffe, 0xfffcfffe, 0xfffcfffe,
	0xfffcfffe, 0xfffcfffe, 0xfffcfffe, 0xfffcfffe, 0xfffcfffe, 0xfffcfffe,
	0xfffffcfe, 0xfffcfffe, 0xffffe7d3, 0xffffb361, 0xffffa546, 0xffffc07e,
	0xffffcc98, 0xffffd8ae, 0xffffe2c2, 0xffffecdd, 0xfffdeee2, 0xffffe8cc,
	0xffffd8ae, 0xffffc78c, 0xffffc07e, 0xffffa546, 0xffffb66e, 0xffffe1c9,
	0xfffffef9, 0xfffcfffe, 0xfffcfffe, 0xfffcfffe, 0xfffcfffe, 0xfffcfffe,
	0xfffcfffe, 0xfffcfffe, 0xfffcfffe, 0xfffcfffe, 0xfffcfffe, 0xfffcfffe,
	0xfffcfffe, 0xfffcfffe, 0xfffcfffe, 0xfffcfffe, 0xfffffef9, 0xfffcfffe,
	0xfffff2e6, 0xfffdcda7, 0xffffb66e, 0xffffab5b, 0xffffaa5a, 0xffffaa5a,
	0xffffab5b, 0xffffaa5a, 0xffffaa5a, 0xffffbb7b, 0xffffd2a3, 0xfffff2e6,
	0xfffcfffe, 0xfffcfffe, 0xfffcfffe, 0xfffcfffe, 0xfffcfffe, 0xfffcfffe,
	0xfffcfffe, 0xfffcfffe, 0xfffcfffe, 0xfffcfffe,};

static unsigned char sdlappicon_mask[] = {
	255, 255, 255, 255, 255, 255, 255, 255, 255, 255, 255, 255, 255, 255,
	255, 255, 255, 255, 255, 255, 255, 255, 255, 255, 255, 255, 255, 255,
	255, 255, 255, 255, 255, 255, 255, 255, 255, 255, 255, 255, 255, 255,
	255, 255, 255, 255, 255, 255, 255, 255, 255, 255, 255, 255, 255, 255,
	255, 255, 255, 255, 255, 255, 255, 255, 255, 255, 255, 255, 255, 255,
	255, 255, 255, 255, 255, 255, 255, 255, 255, 255, 255, 255, 255, 255,
	255, 255, 255, 255, 255, 255, 255, 255, 255, 255, 255, 255, 255, 255,
	255, 255, 255, 255, 255, 255, 255, 255, 255, 255, 255, 255, 255, 255,
	255, 255, 255, 255, 255, 255, 255, 255, 255, 255, 255, 255, 255, 255,
	255, 255,};

struct sdlappicon sdlappicon = {
	32,32,	// width,height
	sdlappicon_pixels,
	sdlappicon_mask
};
